require_relative 'ticketing_hub/configuration'
require_relative 'ticketing_hub/client'
require_relative 'ticketing_hub/error'

module TicketingHub
  extend Configuration

  class << self
    def new options={}
      TicketingHub::Client.new options
    end

    def method_missing method, *args, &block
      return super unless new.respond_to? method
      new.send method, *args, &block
    end

    def respond_to? method, include_private=false
      new.respond_to?(method, include_private) || super(method, include_private)
    end
  end
end