require_relative 'resource'
require_relative 'ticket'

module TicketingHub
  class Order < Resource

    def tickets
      self['tickets'].map do |ticket|
        Ticket.new(client, ticket, "#{path}/#{id}/tickets", ticket.id).tap do |ticket|
          ticket.venue_id = self.id
        end
      end
    end

    def fields
      client.get "#{path}/#{id}/fields"
    end

    def confirm!
      merge! client.post "#{path}/#{id}/confirm"
    rescue TicketingHub::UnprocessableEntity => e
      merge! e.response_body
      raise e
    end
  end
end