require 'hashie'

module TicketingHub
  class Resource < ::Hashie::Mash
    attr_accessor :client, :path, :id

    def initialize(client, values, path, id)
      self.client = client; self.path = path; self.id = id
      super(values)
    end

    def update
      update! attributes
      return true
    rescue TicketingHub::UnprocessableEntity
      return false
    end

    def destroy
      destroy! attributes
      return true
    rescue TicketingHub::UnprocessableEntity
      return false
    end

    def update! attributes
      merge! client.patch("#{path}/#{id}", attributes)
      return self
    rescue TicketingHub::UnprocessableEntity => e
      merge! e.response_body
      raise e
    end

    def destroy!
      merge! client.delete "#{path}/#{id}"
      return self
    rescue TicketingHub::UnprocessableEntity => e
      merge! e.response_body
      raise e
    end
  end
end