require_relative 'resource'
require_relative 'order'

module TicketingHub
  class Ticket < Resource

    def fields
      client.get "#{path}/#{id}/fields"
    end

    def order
      client.get "#{path}/#{id}/order", {}, TicketingHub::Order
    end

    def attended?
      ! attended_at.nil?
    end

    def attend!
      merge! client.post "#{path}/#{id}/attend"
    rescue TicketingHub::UnprocessableEntity => e
      merge! e.response_body
      raise e
    end
  end
end